#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <time.h>

#include "flag_set.h"


int
flag_set_all (void)		/* 全ての列の検索が終わったかを調べる関数 */
{
  int i = 0, j;
  for (j = 0; j < count_q; j++)
    {
      if (flag[j] == 0){i = 0;}else{i++;}
    }
  return (i);
}

int
main (void)
{
  time_t start_time;		/* 開始時間の記録変数            */
  time_t now_time;		/* 現在時間を取り込む変数        */
  FILE *fp;			/* 保存するファイルのポインタ     */
  int *s2;			/* 素数表の配列                  */
  int n;			/* for文用変数                   */
  int position;			/* xxxn+Pの表のポインタ           */
  int n3;			/* */
  int n4;			/* */
  int n5;			/* */
  int n6;			/* 雑用変数                       */
  int k1;			/* 素数候補ポインタ１              */
  int k2;			/* 素数候補ポインタ２              */
  int i;			/* xxxn+Pの表の作成ポインタ        */
  int max;			/* xxxn+Pの表のインデックスの最大値 */
  int j;			/* 素数表印刷用のカウンタ           */
  int j1;			/* 素数候補ポインタ１の示す値       */
  int j2;			/* 素数候補ポインタ２の示す値       */
  int l1;			/* 素数表の列の先頭値               */
  int flag_2;			/* k2ポインタの終了フラグ           */
  int flag_index;		/*  列番号                         */
  int minuts;
  int seconds;
  
  flag_clear();
  s2 = (int *)malloc (sizeof (int) * nn);	/*  素数候補のエラトステネス篩の結果 */

  start_time = time (NULL);

#include "init_table.h"
 
  printf("init table end!\n");

  max = i - 1;
  k1 = 2;
  flag_2 = 0;
  do
    {
      /* 列フラグのクリア   */
      flag_clear();
      k2 = k1;
      flag_2 = 0;
      j1 = s2[k1];
      do
	{
	  /* エラトステネスの篩 */
	  j2 = s2[k2];		/* */
	  l1 = j1 * j2;		/* l1は素数の倍数　 */
	  if (abs (l1) >= abs (s2[max]))
	    {			/*  */
	      flag_2 = 1;
	    }
	  else
	    {
	      k2++;
	      /* n1に初項の順位の取り出し */
	      if (l1 > 0)
		{
		  /* 列フラグのセット */
		  n6 = l1 / P_max;
		   /**/ flag_index = flag_set (l1);
		   /**/ if (flag[flag_index] >0)/* 2011.4.9 ==1 → >0 */
		    {
		      position = n6 * count_q + flag_index + 1;
		      if(n6 > 0) {s2[position] = -l1;}	/* 列の先頭。倍数は負の数とする */
		      /* 列の先頭から列の最終までいっきに表から削除 */
		      n3 = abs (s2[k1]) * count_q;	/* 素数×count_q　縦１行の数   */
		      n4 = position;	                /* 開始位置                   */
		      n5 = (max - position) / n3;	/* 末尾までの繰り返し数        */
		      for (n = 1; n <= n5; n++)/* 2011.4.9 n < n5 → n <= n5*/
			{
			  n4 = n4 + n3;
			  if (n4 < max)
			    {
			      if (s2[n4] > 0)
				{
				  s2[n4] = -s2[n4];
				}
			    }	/* 倍数は負の数とする */
			}	// for
		    }		// if
		}		// if
	    }			//else
	}			// do
      while ((flag_set_all () < count_q) && (flag_2 == 0));

      now_time = time (NULL);	/* 現在時間の取得 */
      /* 以下の3行のコメントを外すと途中結果を表示する。 */
      //minuts=(now_time-start_time)/60;
      //seconds=(now_time-start_time) % 60;
      //printf("篩=%d 経過時間= %d 分 %d 秒 \n",abs(s2[k1]),minuts,seconds);
      do
	{
	  k1++;
	  j1 = s2[k1];
	}			/* 表から基本素数候補をピックアップ */
      while (j1 < 0);
      if (abs (s2[k1]) * abs (s2[k1]) >= s2[max]){ break;}
    }
  while (k1 != nm);

   printf("delete P prime start!\n");

#include "del_P_prime.h" 

/* 完了時間の表示 */
  now_time = time (NULL);	/* 現在時間の取得 */
  minuts = (now_time - start_time) / 60;
  seconds = (now_time - start_time) % 60;
  printf ("篩=%d 経過時間= %d 分 %d 秒 \n", abs (s2[k1]), minuts, seconds);

/* 打ち出し */

/* 保存はカレントディレクトリーのsouuhyoというファイル名で上書きする */
  if ((fp = fopen ("souuhyo", "w")) == NULL)
    {
      printf ("cannot open souuhyo\n");
      exit (1);
    }
  printf ("now saving  disk file!\n");
  j = 0;

  /* Pで省略した素数のうちだし */
  for(i=0;i<prime_table_size;i++){
    fprintf (fp,"%d\t",table[i]);
    j++;
    if (j % 8 == 0){fprintf (fp, ("\n"));}      /* 8個ごとに改行する */
  } 

  /* 求めた素数のうちだし */
  for (i = 2; i < (max - 1); i++)
    {				
      if (s2[i] > 0)
	{
	  if (j % 8 == 0){fprintf (fp, ("\n"));} /* 8個ごとに改行する */
	  fprintf (fp, "%d\t", s2[i]);
	  j++;
	}
    }
  fprintf (fp, ("\n"));
  /* うちだし終了　*/
  fclose (fp);
  printf ("素数個数=%d \n", j);

/* 終わり */
  free (s2);
  return (0);
}
